<div class="title">OS</div>
<?
/*=========================================*/
/* w3Analyzer Plug-in                      */
/*                                         */
/* OS解析 (UPDATE:06/01/08)                */
/*                                         */
/* オーサカPHP | http://fmono.sub.jp/      */
/*                                         */
/*=========================================*/

/*=========================================*/
/* Function                                */
/*=========================================*/
//OS,バージョン
function getuseragent($hua){
	global $os_list;

	//Windows
	if(ereg("Win",$hua)){
		$platform = 'Windows';
		foreach($os_list["win"] as $k => $v){
			if(strstr($hua,$k)){
				$platform_v = $v;
				break;
			}
		}
	}
	//Macintosh
	elseif(ereg("(Mac_PowerPC|Macintosh)",$hua)){
		$platform = 'Macintosh';
		foreach($os_list["mac"] as $k => $v){
			if(strstr($hua,$k)){
				$platform_v = $v;
				break;
			}
		}
	}
	else{
		//その他のOS
		foreach($os_list["other"] as $k => $v){
			if(strstr($hua,$k)){
				$platform = $v;
				break;
			}
		}
		//ロボット
		if(!$platform){
			foreach($os_list["robot"] as $k => $v){
			if(strstr($hua,$k)){
					$platform = "Robot";
					break;
				}
			}
		}
	}
	
	/*---Unknown---*/
	if(!$platform) $platform = 'Unknown OS';
	if(!$platform_v) $platform_v = 'N/A';
	
	return 	array($platform,$platform_v);
}
//ソート用
function cmp($a , $b){
    if ($a["total"] == $b["total"]) return 0;
    return ($a["total"] > $b["total"]) ? -1 : 1;
}

/*=========================================*/
/* 初期化                                  */
/*=========================================*/
//ページ用配列 初期化
$main = array();
//アイコン用配列 初期化
$icon_list = array();

/*=========================================*/
/* リスト読み込み                          */
/*=========================================*/
//OS
$list_fn = "./list/os_win.txt";
if(file_exists($list_fn)) $os_list["win"] = setting_read($list_fn);
$list_fn = "./list/os_mac.txt";
if(file_exists($list_fn)) $os_list["mac"] = setting_read($list_fn);
$list_fn = "./list/os_other.txt";
if(file_exists($list_fn)) $os_list["other"] = setting_read($list_fn);
$list_fn = "./list/os_robot.txt";
if(file_exists($list_fn)) $os_list["robot"] = setting_read($list_fn);
unset($list_fn);
//アイコン
$list_fn = "./list/icon.txt";
if(file_exists($list_fn)) $icon_list = setting_read($list_fn);
unset($list_fn);

/*=========================================*/
/* OSリスト編集                            */
/*=========================================*/
if(is_array($os_list)){
	foreach($os_list as $k => $v){
		unset($tmp);
		foreach($v as $k2 => $v2){
			list($tmp["var"],$tmp["name"]) = explode("||",$v2);
			$os_list[$k][$tmp["var"]] = $tmp["name"];
			unset($os_list[$k][$k2],$tmp);
		}
	}
}

/*=========================================*/
/* アイコンデータ編集                      */
/*=========================================*/
foreach($icon_list as $v){
	list($icon["name"],$icon["path"]) = explode("||",$v);
	//小文字にする
	$icon["name"] = strtolower($icon["name"]);
	$icon_path[$icon["name"]] = $icon["path"];
}

/*=========================================*/
/* データ編集                              */
/*=========================================*/
if(is_array($data)){
	foreach($data as $v){
		if($v["useragent"] == "") continue;
		$ua = getuseragent($v["useragent"]);
		if(!array_key_exists($ua[0],$main)){
			$main[$ua[0]][$ua[1]] = 1;
			$main[$ua[0]]["total"] = 1;
		}else{
			$main[$ua[0]][$ua[1]]++;
			$main[$ua[0]]["total"]++;
		}
		$main["total"]++;
		
		//指定ログ取得
		if(isset($_GET["sel"]) && $ua[0] == $_GET["sel"]) $select[] = $v;
	}
	unset($data);
}

/*=========================================*/
/* 指定ログ                                */
/*=========================================*/
if(isset($_GET["sel"])) mk_select($select);


/*=========================================*/
/* ソート&最大値                           */
/*=========================================*/
uasort($main , "cmp");
//Unknown OSを最後に移動
if(isset($main["Unknown OS"])){
	$tmp = $main["Unknown OS"];
	unset($main["Unknown OS"]);
	$main["Unknown OS"] = $tmp;
}

$max_val = 0;
foreach($main as $k => $v){
	if($k == "total") continue;
	unset($v["total"]);
	if($max_val < @max($v)) $max_val = @max($v);
}

/*=========================================*/
/* メイン処理                              */
/*=========================================*/
echo '<table>';
echo '<tr>';
echo '<th nowrap>OS</th>';
echo '<th nowrap>バージョン</th>';
echo '<th nowrap>件数</th>';
echo '<th nowrap>グラフ</th>';
echo '</tr>';
foreach($main as $k => $v){
	if($k == "total") continue;
	
	//ソート
	arsort($main[$k],SORT_NUMERIC);
	$tmp = "";
	$i = 0;
	foreach($main[$k] as $k2 => $v2){
		if($k2 == "total") continue;
		//link
		if($k == $tmp){
			$link = "&nbsp;";
		}else{
			//icon
			$icon = (isset($icon_path[strtolower($k)]) ? set_img($icondir.$icon_path[strtolower($k)],$k)."&nbsp;" : set_img($icondir."none.gif",$k)."&nbsp;");
			$link = $icon.sel_link(query_edit("sel",$k),$k);
		}
		$tmp = $k;
		
		echo '<tr id="bg_id'.$k.$i.'" onmouseover="chBG(\'bg_id'.$k.$i.'\', 1);" onmouseout="chBG(\'bg_id'.$k.$i.'\', 0);">';
		echo '<td>&nbsp;'.$link.'&nbsp;</td>';
		echo '<td>&nbsp;'.$k2.'&nbsp;</td>';
		echo '<td align="right">&nbsp;'.$v2.'&nbsp;</td>';
		echo '<td>&nbsp;'.mk_graph($v2,$main["total"],$max_val).'&nbsp;</td>';
		echo '</tr>'."\n";
		$i++;
	}
	//合計
	echo '<tr>';
	echo '<td class="bg_total">&nbsp;</td>';
	echo '<td class="bg_total" align="right">&nbsp;<b>合計：</b>&nbsp;</td>';
	echo '<td class="bg_total" align="right">&nbsp;<b>'.$main[$k]["total"].'</b>&nbsp;</td>';
	echo '<td class="bg_total">&nbsp;</td>';
	echo '</tr>'."\n";
}
echo '</table>';
?>